Added iscsi support to debian
authorPravin Shinde <pravin@black-perl.(none)>
Fri, 24 Jul 2009 15:54:07 +0000 (17:54 +0200)
committerPravin Shinde <pravin@black-perl.(none)>
Fri, 24 Jul 2009 15:54:07 +0000 (17:54 +0200)
also preliminary changes in ubuntu for adding same support
Chances in red hat regarding NFS mounting

25 files changed:
pxeknife/debian/debian-live-501-i386/generate_initrd.sh
pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsiadm
pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsid
pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsistart
pxeknife/debian/debian-live-501-i386/live
pxeknife/debian/debian-live-501-i386/modules/crc32c.ko [new file with mode: 0644]
pxeknife/debian/debian-live-501-i386/modules/libcrc32c.ko [new file with mode: 0644]
pxeknife/debian/debian.conf
pxeknife/red_hat/fedora_11_live_cd/init
pxeknife/red_hat/fedora_11_live_cd/mount_nfs_iso.sh
pxeknife/red_hat/fedora_11_live_cd/real-init
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/casper
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/init
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/initiatorname.iscsi [new file with mode: 0644]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/iscsid.conf [new file with mode: 0644]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi-iname [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi_discovery [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsiadm [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsid [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsistart [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/isosize [new file with mode: 0755]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/crc32c.ko [new file with mode: 0644]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/ib_iser.ko [new file with mode: 0644]
pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/libcrc32c.ko [new file with mode: 0644]
pxeknife/ubuntu/ubuntu.conf

index aa3906a..5b76fa1 100755 (executable)
@@ -26,10 +26,9 @@ mkdir mpoint/etc/iscsi
 cp iscsi/iscsid.conf mpoint/etc/iscsi/
 cp iscsi/initiatorname.iscsi mpoint/etc/iscsi/
 cp iscsi/tools/* mpoint/sbin/
-cp strace mpoint/sbin/
-cp passwd mpoint/etc/
-cp group mpoint/etc/
-cp a.out mpoint/bin/
+
+mkdir mpoint/modules
+cp modules/* mpoint/modules/
 
 
 cp httpfs/server/httpfs mpoint/bin/
index ddca8b0..dd05ea1 100755 (executable)
Binary files a/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsiadm and b/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsiadm differ
index 40c3194..8405fff 100755 (executable)
Binary files a/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsid and b/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsid differ
index 0371157..da5ca2d 100755 (executable)
Binary files a/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsistart and b/pxeknife/debian/debian-live-501-i386/iscsi/tools/iscsistart differ
index e56a696..652a1ce 100755 (executable)
@@ -87,6 +87,20 @@ Arguments ()
                 echo "found argument httpfs here ${HTTPFS}"
                                ;;
 
+                       iscsifs=*)
+                               ISCSIFS="${ARGUMENT#iscsifs=}"
+                               export ISCSIFS
+                echo "found argument iscsifs here ${ISCSIFS}"
+                               ;;
+
+
+                       target=*)
+                               TARGET="${ARGUMENT#target=}"
+                               export TARGET 
+                echo "found argument target here ${TARGET}"
+                               ;;
+
+
                        hostname=*)
                                HOSTNAME="${ARGUMENT#hostname=}"
                                LIVECONF="changed"
@@ -728,6 +742,16 @@ do_netmount ()
        fi
     
 
+       if ( [ -n "${ISCSIFS}" ] ) && do_iscsimount
+       then
+        echo "do_iscsimount successful"
+               rc=0
+               return ${rc}
+       fi
+    echo "do_iscsimount failed..."
+
+
+
        if ( [ -n "${FETCH}" ] || [ -n "${HTTPFS}" ] || [ -n "${FTPFS}" ] ) && do_httpmount
        then
         echo "do_httpmount successful"
@@ -757,6 +781,30 @@ do_netmount ()
        return ${rc}
 }
 
+do_iscsimount ()
+{
+       rc=1
+       dest="${mountpoint}/${LIVE_MEDIA_PATH}"
+       mount -t ramfs ram "${mountpoint}"
+       mkdir -p "${dest}"
+
+    echo "inside iscsimount" 
+            
+    insmod /modules/libcrc32c.ko
+    insmod /modules/crc32c.ko
+    modprobe iscsi_tcp
+    modprobe ib_iser
+    mkdir /var/run
+    /sbin/iscsid
+    iscsiadm -m discovery -t st -p "${ISCSIFS}"
+    targetname=`iscsiadm -m node | grep "${TARGET}" | cut -d' ' -f2`
+    iscsiadm -m node --targetname "${targetname}" --portal "${ISCSIFS}" --login
+    sleep 2
+    mount -t iso9660 /dev/sda "${mountpoint}"
+    rc=${?}
+    return $rc
+}
+
 do_httpmount ()
 {
        rc=1
@@ -764,7 +812,7 @@ do_httpmount ()
        mount -t ramfs ram "${mountpoint}"
        mkdir -p "${dest}"
 
-    echo "inside httpmount" >> /mylogs
+    echo "inside httpmount" 
        for webfile in HTTPFS FTPFS FETCH
        do
                url="$(eval echo \"\$\{${webfile}\}\")"
@@ -783,16 +831,8 @@ do_httpmount ()
                echo  "File path is $FILEPATH" 
                losetup "${rootmnt}/dev/loop0" $FILEPATH
                mount -t iso9660 $FILEPATH "${mountpoint}" -o loop -o ro
-            
-            modprobe iscsi_tcp
-            modprobe ib_iser
-            mkdir /var/run
-#            mkdir /etc/iscsi/nodes
-#            /sbin/iscsid
-#            iscsiadm -m discovery -t st -p 192.168.0.1
-            
-
-            return 0
+            rc=${?}
+            return $rc
         else
             echo "not BKO http mount, proceding in normal way"
         fi
diff --git a/pxeknife/debian/debian-live-501-i386/modules/crc32c.ko b/pxeknife/debian/debian-live-501-i386/modules/crc32c.ko
new file mode 100644 (file)
index 0000000..86a05d2
Binary files /dev/null and b/pxeknife/debian/debian-live-501-i386/modules/crc32c.ko differ
diff --git a/pxeknife/debian/debian-live-501-i386/modules/libcrc32c.ko b/pxeknife/debian/debian-live-501-i386/modules/libcrc32c.ko
new file mode 100644 (file)
index 0000000..aac5a1e
Binary files /dev/null and b/pxeknife/debian/debian-live-501-i386/modules/libcrc32c.ko differ
index e163a35..daf249c 100755 (executable)
@@ -53,3 +53,13 @@ label debian-live-501-local
        append netboot=http boot=live union=aufs httpfs=http://192.168.111.11/debian-live-501-i386-gnome-desktop.iso  initrd=pxeknife/debian/debian-live-501-i386/initrd1.img
     IPAPPEND 3
 
+label debian-live-501-local-iscsi
+       MENU LABEL Debian live 501 i386 - iscsi ( localhost)
+    TEXT HELP
+           Used by me for development and testing of iscsi 
+        Dont select it
+    ENDTEXT
+       kernel pxeknife/debian/debian-live-501-i386/vmlinuz1
+       append netboot=http boot=live union=aufs iscsifs=192.168.111.11:3260 target=debian.iso initrd=pxeknife/debian/debian-live-501-i386/initrd1.img
+    IPAPPEND 3
+
index b7dcb76..83469e2 100755 (executable)
@@ -24,7 +24,7 @@ mknod /dev/tty0 c 4 0
 mknod /dev/tty1 c 4 1
 mknod /dev/tty2 c 4 2
 
-echo "Running plymouthd"
+#echo "Running plymouthd"
 #daemonize --ignore-missing /bin/plymouthd
-echo "done with it"
+#echo "done with it"
 exec sbin/real-init
index 4647d04..cd5d6dd 100755 (executable)
@@ -46,15 +46,19 @@ route add default gw $mygw 2> /outputroute
 NFS_PATH=$2
 echo "The NFS mount location is $NFS_PATH"
 echo "mounting NFS"
+
+# mounting ISO
 mkdir /iso
 echo "nfs mounting $NFS_PATH /iso"
 mount "$NFS_PATH" /iso -o nolock
-    
 FILEPATH="/iso/Fedora-11-i686-Live.iso"
 mount -t iso9660 $FILEPATH /sysroot -o loop -o ro
 echo "FILEPATH is $FILEPATH and URL is $ISO_PATH"
 
 
+# mounting the squashfs directly
+# mount "$NFS_PATH" /sysroot -o nolock
+
 # test if fedora is there
 if test -f /sysroot/LiveOS/squashfs.img
 then
index 15e0a59..0080ba6 100755 (executable)
@@ -3,7 +3,7 @@
 echo "ok, inside real init"
 emergency_shell()
 {
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "Bug in initramfs /init detected. Dropping to a shell. Good luck!"
     echo
     bash < /dev/console
@@ -225,7 +225,7 @@ echo "ACTION==\"add\", SUBSYSTEM==\"scsi_device\", SYSFS{type}==\"0|7|14\", RUN+
 echo "ACTION==\"add\", SUBSYSTEM==\"scsi_device\", SYSFS{type}==\"[45]\", RUN+=\"/sbin/modprobe sr_mod\"" >> /etc/udev/rules.d/10-modprobe.rules
 echo "SUBSYSTEM==\"mmc\", RUN+=\"/sbin/modprobe mmc_block\"" >> /etc/udev/rules.d/10-modprobe.rules
 
-echo "ACTION==\"add\", SUBSYSTEM==\"graphics\", KERNEL==\"fb[0-9]*\", RUN+=\"/bin/plymouth --show-splash\"" > /etc/udev/rules.d/20-show-plymouth.rules
+#echo "ACTION==\"add\", SUBSYSTEM==\"graphics\", KERNEL==\"fb[0-9]*\", RUN+=\"/bin/plymouth --show-splash\"" > /etc/udev/rules.d/20-show-plymouth.rules
 
 # FIXME: hack since sr_mod seems to fail to get loaded sometimes (#239657)
 /sbin/modprobe sr_mod 2>/dev/null || :
@@ -243,11 +243,11 @@ fi
 /sbin/udevadm trigger
 
 if [ "$shell" == "1" ] ; then
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "Shell requested on kernel commandline. Exit to continue booting."
     echo
     bash < /dev/console
-    plymouth --show-splash || :
+#    plymouth --show-splash || :
 fi
 
 # don't wait for "mtd0" as no device file will appear
@@ -257,7 +257,7 @@ if [ "$root" != "mtd0" -a -z ${HTTPFS} -a ! -f "$thingtomount" ] ; then
     # If we don't have the /dev/root link.. ask the user to create..
     if [ "$waitforsymlink" != "1" ] ; then
         if [ ! -L /dev/root ] ; then
-            plymouth --hide-splash || :
+#            plymouth --hide-splash || :
             echo
             echo "--------------------------------------"
             echo "WARNING: Cannot find root file system!"
@@ -267,7 +267,7 @@ if [ "$root" != "mtd0" -a -z ${HTTPFS} -a ! -f "$thingtomount" ] ; then
             echo "the boot sequence."
             echo
             bash < /dev/console
-            plymouth --show-splash || :
+#            plymouth --show-splash || :
         fi
     fi
 
@@ -296,7 +296,7 @@ if [ "$root" != "mtd0" -a -z ${HTTPFS} -a ! -f "$thingtomount" ] ; then
     fi
 
     if [ ! -b /dev/root ] ; then
-        plymouth --hide-splash || :
+#        plymouth --hide-splash || :
         echo
         echo "--------------------------------------"
         echo "WARNING: Cannot find root file system!"
@@ -306,7 +306,7 @@ if [ "$root" != "mtd0" -a -z ${HTTPFS} -a ! -f "$thingtomount" ] ; then
         echo "the boot sequence."
         echo
         bash < /dev/console
-        plymouth --show-splash || :
+#        plymouth --show-splash || :
     fi
 
     if [ "$quiet" != "1" ] ; then
@@ -324,7 +324,7 @@ fi
 [ -e /dev/root ] && fs=$(/lib/udev/vol_id -t /dev/root)
 if [ "x$fs" == "xiso9660" -o "x$fs" == "xudf" ]; then checkfs=1 ; fi
 if [ "x$check_iso" == "x1" -a -x /bin/checkisomd5 -a "x$checkfs" == "x1" ]; then
-   plymouth --hide-splash || :
+#   plymouth --hide-splash || :
    echo "Verifying ISO image..."
    /bin/checkisomd5 --verbose /dev/root
    if [ $? -ne 0 ]; then
@@ -332,7 +332,7 @@ if [ "x$check_iso" == "x1" -a -x /bin/checkisomd5 -a "x$checkfs" == "x1" ]; then
        echo "Press Enter to continue or ctrl-alt-del to reboot."
        read < /dev/console
    fi
-   plymouth --show-splash || :
+#   plymouth --show-splash || :
 fi
 
 
@@ -379,7 +379,7 @@ fi
 
 
 if [ "$RES" != "0" ] ; then
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "---------------------------------"
     echo "WARNING: Cannot mount rootfs!"
     echo "---------------------------------"
@@ -388,7 +388,7 @@ if [ "$RES" != "0" ] ; then
     echo "Mount rootfs at /sysroot and exit shell to continue. Good luck!"
     echo
     bash < /dev/console
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
 fi
 
 # Now get ready to leave the initramfs
@@ -621,12 +621,12 @@ if [ -b "$OSMIN_LOOPDEV" ]; then
 fi
 
 if [ "$eshell" == "1" ] ; then
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "Shell requested on kernel commandline."
     echo "Rootfs is mounted ro on /sysroot. Exit to continue booting."
     echo
     bash < /dev/console
-    plymouth --show-splash || :
+#    plymouth --show-splash || :
 fi
 
 
@@ -640,10 +640,10 @@ if [ -x /sysroot$init ] ; then
     
     # If the udev rule doesn't get triggered make sure to
     # show a splash
-    plymouth --show-splash || :
+#    plymouth --show-splash || :
     exec /sbin/run-init
 
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "---------------------------------"
     echo "WARNING: Error switching to real rootfs!"
     echo "---------------------------------"
@@ -652,7 +652,7 @@ if [ -x /sysroot$init ] ; then
     echo
     bash < /dev/console
 else
-    plymouth --hide-splash || :
+#    plymouth --hide-splash || :
     echo "---------------------------------------------------------"
     echo "WARNING: Requested $init binary does not exist on rootfs."
     echo "---------------------------------------------------------"
index 8d23615..77ad48e 100644 (file)
@@ -186,6 +186,8 @@ do_netmount() {
 
     if [ "${NETBOOT}" == "http" ] && do_httpfsmount ; then
         rc=0
+    elif [ "${NETBOOT}" != "iscsi" ] && do_iscsimount ; then
+        rc=0
     elif [ "${NETBOOT}" != "nfs" ] && do_cifsmount ; then
         rc=0
     elif do_nfsmount ; then
@@ -216,6 +218,66 @@ do_nfsmount() {
     return ${rc}
 }
 
+do_httpfsmount() {
+    # objectives: 
+    # Setup networking.
+    # Find the location from which we need to get the ISO.
+    # Mount the ISO.
+    rc=1
+
+       ifconfig lo 127.0.0.1 up
+       ifconfig eth0 up
+    echo "The ip configuration is $ip"
+    myip=`echo $ip | cut -d: -f1`
+    echo "Using ip address $myip"
+    mynm=`echo $ip | cut -d: -f4`
+    echo "Using Netmask $mynm"
+    mygw=`echo $ip | cut -d: -f3`
+    echo "Using gateway ip $mygw"
+    ifconfig eth0 $myip netmask $mynm 
+    echo "verify the ip address"
+    ifconfig eth0
+
+    echo "setting route"
+    route add default gw $mygw 
+
+
+       echo  "passed on path is ${ISCSIFS}" 
+       echo "The location of ubuntu iso  is $ISO_PATH" >> /output
+       echo "mounting CDROM" >> /output
+
+
+#      losetup -r /dev/loop0 $FILEPATH
+#      busybox mount -t iso9660 $FILEPATH "${mountpoint}" -o loop -o ro
+
+    echo "inside iscsimount" 
+            
+    insmod /modules/libcrc32c.ko
+    insmod /modules/crc32c.ko
+    modprobe iscsi_tcp
+    modprobe ib_iser
+    mkdir /var/run
+    /sbin/iscsid
+    iscsiadm -m discovery -t st -p "${ISCSIFS}"
+    targetname=`iscsiadm -m node | grep "${TARGET}" | cut -d' ' -f2`
+    iscsiadm -m node --targetname "${targetname}" --portal "${ISCSIFS}" --login
+    sleep 2
+    mount -t iso9660 /dev/sda "${mountpoint}"
+    rc=${?}
+    return $rc
+
+
+       # test if knoppix is there
+       if test -d /cdrom/casper
+       then
+               echo "successfully mounted the Image" >> /output
+               return 0
+       fi
+       return ${rc}
+
+}
+
+
 do_httpfsmount() {
     # objectives: 
     # Enable networking.
index 28a7c86..83b937b 100755 (executable)
@@ -131,6 +131,9 @@ for x in $(cat /proc/cmdline); do
        httpfs=*)
                HTTPFS="${x#httpfs=}"
                ;;
+       iscsifs=*)
+               ISCSIFS="${x#iscsifs=}"
+               ;;
        netboot=*)
                NETBOOT="${x#netboot=}"
                ;;
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/initiatorname.iscsi b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/initiatorname.iscsi
new file mode 100644 (file)
index 0000000..a732d75
--- /dev/null
@@ -0,0 +1,6 @@
+## DO NOT EDIT OR REMOVE THIS FILE!
+## If you remove this file, the iSCSI daemon will not start.
+## If you change the InitiatorName, existing access control lists
+## may reject this initiator.  The InitiatorName must be unique
+## for each iSCSI initiator.  Do NOT duplicate iSCSI InitiatorNames.
+InitiatorName=iqn.1993-08.org.debian:01:74e6bd2d995f
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/iscsid.conf b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/iscsid.conf
new file mode 100644 (file)
index 0000000..83200c2
--- /dev/null
@@ -0,0 +1,245 @@
+#
+# Open-iSCSI default configuration.
+# Could be located at /etc/iscsi/iscsid.conf or ~/.iscsid.conf
+#
+# Note: To set any of these values for a specific node/session run
+# the iscsiadm --mode node --op command for the value. See the README
+# and man page for iscsiadm for details on the --op command.
+#
+
+################
+# iSNS settings
+################
+# Address of iSNS server
+#isns.address = 192.168.0.1
+#isns.port = 3205
+
+#############################
+# NIC/HBA and driver settings
+#############################
+# open-iscsi can create a session and bind it to a NIC/HBA.
+# To set this up see the example iface config file.
+
+#*****************
+# Startup settings
+#*****************
+
+# To request that the iscsi initd scripts startup a session set to "automatic".
+node.startup = automatic
+#
+# To manually startup the session set to "manual". The default is manual.
+#node.startup = manual
+
+# *************
+# CHAP Settings
+# *************
+
+# To enable CHAP authentication set node.session.auth.authmethod
+# to CHAP. The default is None.
+#node.session.auth.authmethod = CHAP
+
+# To set a CHAP username and password for initiator
+# authentication by the target(s), uncomment the following lines:
+#node.session.auth.username = username
+#node.session.auth.password = password
+
+# To set a CHAP username and password for target(s)
+# authentication by the initiator, uncomment the following lines:
+#node.session.auth.username_in = username_in
+#node.session.auth.password_in = password_in
+
+# To enable CHAP authentication for a discovery session to the target
+# set discovery.sendtargets.auth.authmethod to CHAP. The default is None.
+#discovery.sendtargets.auth.authmethod = CHAP
+
+# To set a discovery session CHAP username and password for the initiator
+# authentication by the target(s), uncomment the following lines:
+#discovery.sendtargets.auth.username = username
+#discovery.sendtargets.auth.password = password
+
+# To set a discovery session CHAP username and password for target(s)
+# authentication by the initiator, uncomment the following lines:
+#discovery.sendtargets.auth.username_in = username_in
+#discovery.sendtargets.auth.password_in = password_in
+
+# ********
+# Timeouts
+# ********
+#
+# See the iSCSI REAME's Advanced Configuration section for tips
+# on setting timeouts when using multipath or doing root over iSCSI.
+#
+# To specify the length of time to wait for session re-establishment
+# before failing SCSI commands back to the application when running
+# the Linux SCSI Layer error handler, edit the line.
+# The value is in seconds and the default is 120 seconds.
+node.session.timeo.replacement_timeout = 120
+
+# To specify the time to wait for login to complete, edit the line.
+# The value is in seconds and the default is 15 seconds.
+node.conn[0].timeo.login_timeout = 15
+
+# To specify the time to wait for logout to complete, edit the line.
+# The value is in seconds and the default is 15 seconds.
+node.conn[0].timeo.logout_timeout = 15
+
+# Time interval to wait for on connection before sending a ping.
+node.conn[0].timeo.noop_out_interval = 5
+
+# To specify the time to wait for a Nop-out response before failing
+# the connection, edit this line. Failing the connection will
+# cause IO to be failed back to the SCSI layer. If using dm-multipath
+# this will cause the IO to be failed to the multipath layer.
+node.conn[0].timeo.noop_out_timeout = 5
+
+# To specify the time to wait for abort response before
+# failing the operation and trying a logical unit reset edit the line.
+# The value is in seconds and the default is 15 seconds.
+node.session.err_timeo.abort_timeout = 15
+
+# To specify the time to wait for a logical unit response
+# before failing the operation and trying session re-establishment
+# edit the line.
+# The value is in seconds and the default is 30 seconds.
+node.session.err_timeo.lu_reset_timeout = 20
+
+#******
+# Retry
+#******
+
+# To specify the number of times iscsid should retry a login
+# if the login attempt fails due to the node.conn[0].timeo.login_timeout
+# expiring modify the following line. Note that if the login fails
+# quickly (before node.conn[0].timeo.login_timeout fires) because the network
+# layer or the target returns an error, iscsid may retry the login more than
+# node.session.initial_login_retry_max times.
+#
+# This retry count along with node.conn[0].timeo.login_timeout
+# determines the maximum amount of time iscsid will try to
+# establish the initial login. node.session.initial_login_retry_max is
+# multiplied by the node.conn[0].timeo.login_timeout to determine the
+# maximum amount.
+#
+# The default node.session.initial_login_retry_max is 8 and
+# node.conn[0].timeo.login_timeout is 15 so we have:
+#
+# node.conn[0].timeo.login_timeout * node.session.initial_login_retry_max =
+#                                                              120 seconds
+#
+# Valid values are any integer value. This only
+# affects the initial login. Setting it to a high value can slow
+# down the iscsi service startup. Setting it to a low value can
+# cause a session to not get logged into, if there are distuptions
+# during startup or if the network is not ready at that time.
+node.session.initial_login_retry_max = 8
+
+################################
+# session and device queue depth
+################################
+
+# To control how many commands the session will queue set
+# node.session.cmds_max to an integer between 2 and 2048 that is also
+# a power of 2. The default is 128.
+node.session.cmds_max = 128
+
+# To control the device's queue depth set node.session.queue_depth
+# to a value between 1 and 128. The default is 32.
+node.session.queue_depth = 32
+
+#***************
+# iSCSI settings
+#***************
+
+# To enable R2T flow control (i.e., the initiator must wait for an R2T
+# command before sending any data), uncomment the following line:
+#
+#node.session.iscsi.InitialR2T = Yes
+#
+# To disable R2T flow control (i.e., the initiator has an implied
+# initial R2T of "FirstBurstLength" at offset 0), uncomment the following line:
+#
+# The defaults is No.
+node.session.iscsi.InitialR2T = No
+
+#
+# To disable immediate data (i.e., the initiator does not send
+# unsolicited data with the iSCSI command PDU), uncomment the following line:
+#
+#node.session.iscsi.ImmediateData = No
+#
+# To enable immediate data (i.e., the initiator sends unsolicited data
+# with the iSCSI command packet), uncomment the following line:
+#
+# The default is Yes
+node.session.iscsi.ImmediateData = Yes
+
+# To specify the maximum number of unsolicited data bytes the initiator
+# can send in an iSCSI PDU to a target, edit the following line.
+#
+# The value is the number of bytes in the range of 512 to (2^24-1) and
+# the default is 262144
+node.session.iscsi.FirstBurstLength = 262144
+
+# To specify the maximum SCSI payload that the initiator will negotiate
+# with the target for, edit the following line.
+#
+# The value is the number of bytes in the range of 512 to (2^24-1) and
+# the defauls it 16776192
+node.session.iscsi.MaxBurstLength = 16776192
+
+# To specify the maximum number of data bytes the initiator can receive
+# in an iSCSI PDU from a target, edit the following line.
+#
+# The value is the number of bytes in the range of 512 to (2^24-1) and
+# the default is 131072
+node.conn[0].iscsi.MaxRecvDataSegmentLength = 131072
+
+
+# To specify the maximum number of data bytes the initiator can receive
+# in an iSCSI PDU from a target during a discovery session, edit the
+# following line.
+#
+# The value is the number of bytes in the range of 512 to (2^24-1) and
+# the default is 32768
+# 
+discovery.sendtargets.iscsi.MaxRecvDataSegmentLength = 32768
+
+# To allow the targets to control the setting of the digest checking,
+# with the initiator requesting a preference of enabling the checking, uncomment# one or both of the following lines:
+#node.conn[0].iscsi.HeaderDigest = CRC32C,None
+#node.conn[0].iscsi.DataDigest = CRC32C,None
+#
+# To allow the targets to control the setting of the digest checking,
+# with the initiator requesting a preference of disabling the checking,
+# uncomment one or both of the following lines:
+#node.conn[0].iscsi.HeaderDigest = None,CRC32C
+#node.conn[0].iscsi.DataDigest = None,CRC32C
+#
+# To enable CRC32C digest checking for the header and/or data part of
+# iSCSI PDUs, uncomment one or both of the following lines:
+#node.conn[0].iscsi.HeaderDigest = CRC32C
+#node.conn[0].iscsi.DataDigest = CRC32C
+#
+# To disable digest checking for the header and/or data part of
+# iSCSI PDUs, uncomment one or both of the following lines:
+#node.conn[0].iscsi.HeaderDigest = None
+#node.conn[0].iscsi.DataDigest = None
+#
+# The default is to never use DataDigests or HeaderDigests.
+#
+
+
+#************
+# Workarounds
+#************
+
+# Some targets like IET prefer after an initiator has sent a task
+# management function like an ABORT TASK or LOGICAL UNIT RESET, that
+# it does not respond to PDUs like R2Ts. To enable this behavior uncomment
+# the following line (The default behavior is Yes):
+node.session.iscsi.FastAbort = Yes
+
+# Some targets like Equalogic prefer that after an initiator has sent
+# a task management function like an ABORT TASK or LOGICAL UNIT RESET, that
+# it continue to respond to R2Ts. To enable this uncomment this line
+# node.session.iscsi.FastAbort = No
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi-iname b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi-iname
new file mode 100755 (executable)
index 0000000..8afc1ba
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi-iname differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi_discovery b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsi_discovery
new file mode 100755 (executable)
index 0000000..398a6e8
--- /dev/null
@@ -0,0 +1,188 @@
+#!/bin/sh
+#
+# Copyright (C) Voltaire Ltd. 2006.  ALL RIGHTS RESERVED.
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License as published by the Free Software
+# Foundation; either version 2 of the License, or (at your option) any later
+# version.
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA 02111-1307 USA
+#
+# Author: Dan Bar Dov <danb@voltaire.com>
+
+# iscsi_discovery:
+#    * does a send-targets discovery to the given IP
+#    * set the transport type to the preferred transport (or tcp is -t flag is not used)
+#    * tries to login
+#    * if succeeds,
+#          o logout,
+#          o mark record autmatic (unless -m flag is used)
+#    * else
+#          o reset transport type to TCP
+#          o try to login
+#          o if succeeded
+#                + logout
+#                + mark record automatic (unless -m flag is used)
+#
+
+usage()
+{
+       echo "Usage: $0 <IP> [-p <port>] [-d] [-t <tcp|iser> [-f]] [-m] [-l]"
+       echo "Options:"
+       echo  "-p               set the port number (defualt is 3260)."
+       echo  "-d               print debugging information"
+       echo  "-t               set trasnpot (default is tcp)."
+       echo  "-f               force specific transport -disable the fallback to tcp (default is fallback enabled)."
+       echo  "                 force the transport specified by the argument of the -t flag."
+       echo  "-m               manual startup - will set manual startup (default is automatic startup)."
+       echo  "-l               login to the new discovered nodes (defualt is false)."
+}
+
+dbg()
+{
+       $debug && echo $@
+}
+
+initialize()
+{
+       trap "exit" 2
+       debug=false
+       force="0"
+       log_out="1"
+       startup_manual="0"
+       #set defualt transport to tcp
+       transport=tcp
+       #set defualt port to 3260
+       port=3260;
+}
+
+parse_cmdline()
+{
+       if [ $# -lt 1 ]; then
+               usage
+               exit 1
+       fi
+
+       # check if the IP address is valid
+       ip=`echo $1 | awk -F'.' '$1 != "" && $1 <=255 && $2 != "" && $2 <= 255 && $3 != "" && $3 <= 255 && $4 != "" && $4 <= 255 {print $0}'`
+       if [ -z "$ip" ]; then
+               echo "$1 is not a vaild IP address!"
+               exit 1
+       fi
+       shift
+       while getopts "dfmlt:p:" options; do
+        case $options in
+               d ) debug=true;;
+               f ) force="1";;
+               t ) transport=$OPTARG;;
+               p ) port=$OPTARG;;
+               m ) startup_manual="1";;
+               l ) log_out=0;;
+               \? ) usage
+                       exit 1;;
+               * )  usage
+                       exit 1;;
+        esac
+       done
+}
+
+discover()
+{
+       # If open-iscsi is already logged in to the portal, exit
+       if [ $(iscsiadm -m session | grep -c ${ip}:${port}) -ne 0 ]; then
+               echo "Please logout from all targets on ${ip}:${port} before trying to run discovery on that portal"
+               exit 2
+       fi
+
+       connected=0
+       discovered=0
+       df=/tmp/discovered.$$
+
+       dbg "starting discovery to $ip"
+       iscsiadm -m discovery --type sendtargets --portal ${ip}:${port} > ${df}
+       while read portal target
+       do
+               portal=${portal%,*}
+               select_transport
+       done < ${df}
+
+       discovered=$(cat ${df} | wc -l)
+       if [ ${discovered} = 0 ]; then
+               echo "failed to discover targets at ${ip}"
+               exit 2
+       else
+               echo "discovered ${discovered} targets at ${ip}"
+       fi
+       /bin/rm -f ${df}
+}
+
+try_login()
+{
+       if [ "$startup_manual" != "1" ]; then
+               iscsiadm -m node --targetname ${target} --portal ${portal} --op update -n node.conn[0].startup -v automatic
+       fi
+       iscsiadm -m node --targetname ${target} --portal ${portal} --login >/dev/null 2>&1
+       ret=$?
+       if [ ${ret} = 0 ]; then
+               echo "Set target ${target} to automatic login over ${transport} to portal ${portal}"
+               connected=$(($connected + 1))
+               if [ "$log_out" = "1" ]; then
+                       iscsiadm -m node --targetname ${target} --portal ${portal} --logout
+               fi
+       else
+               echo "Cannot login over ${transport} to portal ${portal}"
+               iscsiadm -m node --targetname ${target} --portal ${portal} --op update -n node.conn[0].startup -v manual
+       fi
+       return ${ret}
+}
+
+set_transport()
+{
+       transport=$1
+       if [ "$transport" == "iser" ];then
+               iscsiadm -m node --targetname ${target} --portal ${portal} \
+                               --op update -n node.conn[0].iscsi.HeaderDigest -v None
+               iscsiadm -m node --targetname ${target} --portal ${portal} \
+                               --op update -n node.conn[0].iscsi.DataDigest -v None
+       fi
+       transport_name=`iscsiadm  -m node -p ${portal} -T ${target} |awk '/transport_name/ {print $1}'`
+       iscsiadm -m node --targetname ${target} --portal ${portal} \
+                       --op update -n ${transport_name} -v ${transport}
+}
+
+select_transport()
+{
+       set_transport $transport
+       dbg "Testing $transport-login to target ${target} portal ${portal}"
+       try_login;
+       if [ $? != 0 -a  "$force" = "0" ]; then
+               set_transport tcp
+               dbg "starting to test tcp-login to target ${target} portal ${portal}"
+               try_login;
+       fi
+}
+
+check_iscsid()
+{
+       #check if iscsid is running
+       pidof iscsid &>/dev/null
+       ret=$?
+       if [ $ret -ne 0 ]; then
+               echo "iscsid is not running"
+               echo "Exiting..."
+               exit 1
+       fi
+}
+
+check_iscsid
+initialize
+parse_cmdline "$@"
+discover
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsiadm b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsiadm
new file mode 100755 (executable)
index 0000000..dd05ea1
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsiadm differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsid b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsid
new file mode 100755 (executable)
index 0000000..8405fff
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsid differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsistart b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsistart
new file mode 100755 (executable)
index 0000000..da5ca2d
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/iscsistart differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/isosize b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/isosize
new file mode 100755 (executable)
index 0000000..ae09dcc
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/iscsi/tools/isosize differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/crc32c.ko b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/crc32c.ko
new file mode 100644 (file)
index 0000000..85db3f6
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/crc32c.ko differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/ib_iser.ko b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/ib_iser.ko
new file mode 100644 (file)
index 0000000..e0f8fef
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/ib_iser.ko differ
diff --git a/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/libcrc32c.ko b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/libcrc32c.ko
new file mode 100644 (file)
index 0000000..e7e6eac
Binary files /dev/null and b/pxeknife/ubuntu/ubuntu-9.04-desktop-i386/modules/libcrc32c.ko differ
index 5ffce41..49d542f 100755 (executable)
@@ -53,3 +53,13 @@ label ubuntu904desktopi386-laptop-squash
        append  file=/cdrom/preseed/ubuntu.seed netboot=http boot=casper httpfs=http://192.168.111.11/U/filesystem.squashfs  initrd=pxeknife/ubuntu/ubuntu-9.04-desktop-i386/initrd.gz
     IPAPPEND 3
 
+label ubuntu904desktopi386-laptop-iscsi
+       MENU LABEL Ubuntu 9.04 Desktop i386 - local iscsi
+    TEXT HELP
+           Used by me for development and testing iscsi 
+        Dont select it
+    ENDTEXT
+       kernel pxeknife/ubuntu/ubuntu-9.04-desktop-i386/vmlinuz
+       append  file=/cdrom/preseed/ubuntu.seed netboot=iscsi boot=casper iscsifs=192.168.111.11:3260   target=ubuntu.iso initrd=pxeknife/ubuntu/ubuntu-9.04-desktop-i386/initrd.gz
+    IPAPPEND 3
+